/*
 * Enemy4.java
 *
 * Last modified: <2008/08/29 07:12:24 +0900> By SUMIDA
 */
package game;

public class Enemy4 implements EnemyModule {

    public void init(Ship.Info info) {

        Logging.trace("info=" + info + ", id=" + info.id);
        info.sprite.options |= 13;
        info.sprite.dy = Real.IntToReal(1);
    }

    public void action(Ship.Info info) {

        switch (info.stat) {
        case Ship.SHIP_STAT_APPEAR:
            if (info.count < 0) {
                info.count = 5;
                info.stat = Ship.SHIP_STAT_MOVE;
            }
            break;

        case Ship.SHIP_STAT_MOVE:
            if (info.count < 0) {
                /* 自機側に方向変更 */
                if (info.sprite.x < MyShip.ship.sprite.x)
                    info.sprite.dx = Real.IntToReal((int)SystemInfo.Random(2, 6));
                else if (info.sprite.x > MyShip.ship.sprite.x)
                    info.sprite.dx = -Real.IntToReal((int)SystemInfo.Random(2, 6));
                else
                    info.sprite.dx = 0;

                info.count = 5;
                info.stat = Ship.SHIP_STAT_NORMAL;
            }
            break;

        case Ship.SHIP_STAT_NORMAL:
            if (info.count < 0 && SystemInfo.Random(0, 128) < SystemInfo.level) {
                info.sprite.dx = 0;
                info.sprite.dy = Real.IntToReal(1)>>1;
                info.count = 5;
                info.stat = Ship.SHIP_STAT_FIRE;
            }
            break;

        case Ship.SHIP_STAT_FIRE:
            if (info.count < 0 && SystemInfo.Random(0, 128) < SystemInfo.level) {
                /* レーザーの発射 */
                Shot.Info shot1 = Shot.getInfo(Enemy.enemy_shot_mgr, Shot.SHOT_ID_RAY1);
                Shot.Info shot2 = Shot.getInfo(Enemy.enemy_shot_mgr, Shot.SHOT_ID_RAY1);

                if (shot1 != null) {
                    Shot.fire(shot1, info, Real.IntToReal(-16), 0);
                    shot1.sprite.dy = Real.IntToReal(2);
                }

                if (shot2 != null) {
                    Shot.fire(shot2, info, Real.IntToReal(16), 0);
                    shot2.sprite.dy = Real.IntToReal(2);
                    Sound.playEffect(Audio.SE_SHOT0);
                }

                info.sprite.dy = Real.IntToReal(1);
                info.count = 20;
                info.stat = Ship.SHIP_STAT_MOVE;
            }
            break;

        default:
            return;
        }
    }

    public void term(Ship.Info info) {
        Logging.trace("info=" + info);
    }
}
