/*
 * Enemy5.java
 *
 * Last modified: <2008/08/29 07:12:31 +0900> By SUMIDA
 */
package game;

public class Enemy5 implements EnemyModule {

    public void init(Ship.Info info) {

        Logging.trace("info=" + info + ", id=" + info.id);
        info.sprite.options |= 14;
        info.sprite.dy = Real.IntToReal(1);
    }

    public void action(Ship.Info info) {

        switch (info.stat) {
        case Ship.SHIP_STAT_APPEAR:
            /* 自機側に方向変更 */
            if (info.sprite.x < MyShip.ship.sprite.x && info.sprite.dx < 0
                || info.sprite.x > MyShip.ship.sprite.x && info.sprite.dx > 0) {

                info.sprite.dx = -info.sprite.dx;
            }

            if (info.count < 0) {
                info.count = 5;
                info.stat = Ship.SHIP_STAT_MOVE;
            }
            break;

        case Ship.SHIP_STAT_MOVE:
            if (info.count < 0) {
                info.count = 5;
                info.stat = Ship.SHIP_STAT_NORMAL;
            }
            break;

        case Ship.SHIP_STAT_NORMAL:
            if (info.count < 0 && SystemInfo.Random(0, 128) < SystemInfo.level) {
                info.count = 5;
                info.stat = Ship.SHIP_STAT_FIRE;
            }
            break;

        case Ship.SHIP_STAT_FIRE:
            if (info.count < 0 && SystemInfo.Random(0, 128) < SystemInfo.level) {
                /* ミサイルの発射 */
                Ship.Info missile = Enemy.getInfo(Ship.SHIP_ID_MISSILE,
                                                  info.sprite.x + Real.IntToReal(30-8),
                                                  info.sprite.y);

                if (missile != null) {

                    //trace(String.format("info.sprite.x=%d, info.sprite.y=%d, missile.sprite.x=%d, missile.sprite.y=%d",
                    //              info.sprite.x, info.sprite.y, missile.sprite.x, missile.sprite.y));
                    Sound.playEffect(Audio.SE_SHOT2);
                }

                info.count = 10;
                info.stat = Ship.SHIP_STAT_MOVE;
            }
            break;

        default:
            return;
        }
    }

    public void term(Ship.Info info) {
        Logging.trace("info=" + info);
    }
}
