/*
 * MyShip.java
 *
 * Last modified: <2008/08/22 22:27:22 +0900> By SUMIDA
 */
package game;

public class MyShip {

    public static final short SIDE_SPACE   = 30;
    public static final short BOTTOM_SPACE = 30;
    public static Ship.Manager ship_mgr = new Ship.Manager();
    public static Shot.Manager ship_shot_mgr = new Shot.Manager();

    public static Ship.Info ship = null;

    /* 自機の初期化  */
    public static void init() {
        Ship.init(ship_mgr, SystemInfo.SHIP_MAX);
        Shot.init(ship_shot_mgr, SystemInfo.SHIP_SHOT_MAX);
        ship = Ship.getInfo(ship_mgr, Ship.SHIP_ID_ME);
        ship.sprite.x = Real.IntToReal(SystemInfo.WIDTH / 2 - 30);
        ship.sprite.y = Real.IntToReal(SystemInfo.HEIGHT    - 60);
    }

    /* 自機の制御 */
    public static void action() {

        /* 自機の操作 */
        if ((Input.input[Input.P1] & Input.INPUT_PRESS_LEFT)  != 0) ship.sprite.x -= Real.IntToReal(2);
        if ((Input.input[Input.P1] & Input.INPUT_PRESS_RIGHT) != 0) ship.sprite.x += Real.IntToReal(2);
        if ((Input.input[Input.P1] & Input.INPUT_PRESS_UP)    != 0) ship.sprite.y -= Real.IntToReal(2);
        if ((Input.input[Input.P1] & Input.INPUT_PRESS_DOWN)  != 0) ship.sprite.y += Real.IntToReal(2);

        if (ship.sprite.x < Real.IntToReal(-SIDE_SPACE))           ship.sprite.x = Real.IntToReal(-SIDE_SPACE);
        if (ship.sprite.x > Real.IntToReal(SystemInfo.WIDTH - SIDE_SPACE))    ship.sprite.x = Real.IntToReal(SystemInfo.WIDTH - 30);
        if (ship.sprite.y < 0)                                ship.sprite.y = 0;
        if (ship.sprite.y > Real.IntToReal(SystemInfo.HEIGHT - BOTTOM_SPACE)) ship.sprite.y = Real.IntToReal(SystemInfo.HEIGHT - BOTTOM_SPACE);

        if ((Input.input[Input.P1] & Input.INPUT_REPEAT_BUTTON1) != 0 && ship.stat != Ship.SHIP_STAT_LOST) {
            Shot.Info shot = Shot.getInfo(ship_shot_mgr, Shot.SHOT_ID_NORMAL);
            if (shot != null) {
                Shot.fire(shot, ship, 0, -32);
                shot.sprite.dy = Real.IntToReal(-16);
            }
        }

        /* スプライトの制御 */
        Sprite.action(ship.sprite);

        /* 状況に応じた制御 */
        switch (ship.stat) {
        case Ship.SHIP_STAT_EXPLOSION:
            if (ship.count == 0) {
                Sound.stopEffect();
            }
            Sound.playEffect(Audio.SE_BOMB2);
            if (ship.count++ > 2) {
                ship.stat = Ship.SHIP_STAT_LOST;
                SystemInfo.status = SystemInfo.SYSTEM_MODE_OVER;
                Sound.playMusic(Audio.BGM_OVER, -1);
            }
            break;
        }

        /* スプライトの表示 */
        if (ship.stat != Ship.SHIP_STAT_LOST) {
            Sprite.put(ship.sprite);
        }
    }
}
